package application;
	
import java.awt.Font;
import java.awt.FontFormatException;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.stage.FileChooser;
import javafx.application.Application;
import javafx.application.HostServices;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.HPos;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.geometry.Rectangle2D;
import javafx.stage.Screen;
import javafx.stage.Stage;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.ColorPicker;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.control.Tooltip;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Region;
import javafx.scene.layout.RowConstraints;
import javafx.scene.layout.StackPane;
import javafx.scene.shape.Circle;

public class Borumir extends Application 
{	private GridPane hPanel,lPanel,bPanel,rPanel,gPanel;
	private BorderPane borderPane;
	private File mont,codice,stile,webPage,close,enlarge,finestra;
	private TextField nome,materia,autore,nomec,sfondoc,titolo;
	private TextArea testoc,appro_text;
	private ChoiceBox<String> n_cols,n_rows,numeroc,numeror,span_col,span_row,appro,alli_combo,finestra_dxsx;
	private Button crea_cella,anteprima,tutorial,esempi,salva,apri,colorec,reset,immagine,acapo1,acapo2,grassetto1,grassetto2,annulla,pulisci;
	private String colorS;
	private ArrayList <String> cell_names,cell_text,cell_style,cell_appro,cell_audio,cell_web,appro_web;
	private ArrayList <Integer> cell_row,cell_span_row,cell_col,cell_span_col;
	private ArrayList <ArrayList<Button>> cellB;
	private FileChooser chooser;
	private int geco;
	
	public static void main(String[] args)
	{	Application.launch(args);
	}	
	
	public void start(Stage primaryStage) 
	{	primaryStage.setTitle("mappe interattive multimediali");
		borderPane=new BorderPane();
		borderPane.setPadding(new Insets(2,10,2,10));
		hPanel=new GridPane();
		lPanel=new GridPane();bPanel=new GridPane();
		geco=0;
		//textfield textarea
		nome=new TextField("");nome.setPromptText("nome mappa");
		materia=new TextField("");materia.setPromptText("materia");
		autore=new TextField("");autore.setPromptText("autore");
		nomec=new TextField("");nomec.setPromptText("nome cella");
		Tooltip nomec_tip=new Tooltip("nome cella, si consiglia una parola sola, in minuscolo");
		nomec.setTooltip(nomec_tip);
		testoc=new TextArea("");testoc.setPrefSize(150,50);testoc.setPromptText("testo cella");
		Tooltip testoc_tip=new Tooltip("testo della cella");testoc.setWrapText(true);
		testoc.setTooltip(testoc_tip);		
		sfondoc=new TextField();sfondoc.setEditable(false);sfondoc.setPromptText("#ffffff");		
		titolo=new TextField("");Tooltip titolo_tip=new Tooltip("definisce il titolo della finestra di approfondimento");
		titolo.setTooltip(titolo_tip);titolo.setPromptText("titolo della finestra");		
		appro_text=new TextArea("");appro_text.setPrefSize(300,200);
		Tooltip appro_text_tip=new Tooltip("testo della finestra di approfondimento");
		appro_text.setTooltip(appro_text_tip);	appro_text.setPromptText("testo della finestra");
		appro_text.setWrapText(true);
        Image image = new Image("File:imgs/borumir.png",160,66,false,false);
      //font
      	mont=new File("font/Economica-Regular-OTF.otf");
      	try 
      	{	Font.createFont(Font.TRUETYPE_FONT, mont);		
      	} 
      	catch (FontFormatException | IOException e) 
      	{	// TODO Auto-generated catch block
      		e.printStackTrace();
      	}
      	//choicebox
		ObservableList n_c=FXCollections.observableArrayList();
		n_c.addAll("colonne","8","9","10","11","12","13","14","15","16");
		ObservableList n_cp=FXCollections.observableArrayList();
		n_cp.addAll("colonna","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16");
		ObservableList n_r=FXCollections.observableArrayList();
		n_r.addAll("righe","4","5","6","7","8","9","10");
		ObservableList n_rp=FXCollections.observableArrayList();
		n_rp.addAll("riga","1","2","3","4","5","6","7","8","9","10");
		ObservableList span_cr=FXCollections.observableArrayList();
		span_cr.addAll("span","1","2","3","4");
		ObservableList yes=FXCollections.observableArrayList();
		yes.addAll("finestra","no","si");
		ObservableList alli=FXCollections.observableArrayList();
		alli.addAll("allineamento","al centro","a sinistra","a destra");
		ObservableList dxsx=FXCollections.observableArrayList();
		dxsx.addAll("allineamento","sinistra","destra");
		n_cols=new ChoiceBox<String>(n_c);n_cols.getSelectionModel().select(0);
		Tooltip n_cols_tip=new Tooltip("scegli il numero delle colonne della mappa");
		n_cols.setTooltip(n_cols_tip);
		n_rows=new ChoiceBox<String>(n_r);n_rows.getSelectionModel().select(0);
		Tooltip n_rows_tip=new Tooltip("scegli il numero delle righe della mappa");
		n_rows.setTooltip(n_rows_tip);
		numeroc=new ChoiceBox<String>(n_cp);numeroc.getSelectionModel().select(0);
		Tooltip numeroc_tip=new Tooltip("in quale colonna vuoi la cella?");
		numeroc.setTooltip(numeroc_tip);
		numeror=new ChoiceBox<String>(n_rp);numeror.getSelectionModel().select(0);
		Tooltip numeror_tip=new Tooltip("in quale riga vuoi la cella?");
		numeror.setTooltip(numeror_tip);
		span_col=new ChoiceBox<String>(span_cr);span_col.getSelectionModel().select(0);
		Tooltip span_col_tip=new Tooltip("quante colonne vuoi che occupi la cella?");
		span_col.setTooltip(span_col_tip);
		span_row=new ChoiceBox<String>(span_cr);span_row.getSelectionModel().select(0);
		Tooltip span_row_tip= new Tooltip("quante righe vuoi che occupi la cella?");
		span_row.setTooltip(span_row_tip);
		appro=new ChoiceBox<String>(yes);appro.getSelectionModel().select(1);appro.setDisable(true);
		Tooltip appro_tip=new Tooltip("vuoi creare una finestra di approfondimento?");
		appro.setTooltip(appro_tip);
		alli_combo=new ChoiceBox<String>(alli);alli_combo.getSelectionModel().select(0);
		Tooltip alli_combo_tip=new Tooltip("come vuoi allineare il testo nella cella?"); 
		alli_combo.setTooltip(alli_combo_tip);
		finestra_dxsx=new ChoiceBox<String>(dxsx);finestra_dxsx.getSelectionModel().select(0);
		Tooltip finestra_dxsx_tip=new Tooltip("se la cella è sulla sinistra della mappa meglio che la finestra sia a destra e viceversa");
		finestra_dxsx.setTooltip(finestra_dxsx_tip);
        //buttons
      	acapo1=new Button("a capo");acapo2=new Button("a capo");
		Tooltip acapo_tip=new Tooltip("manda a capo il testo dove è posizionato il cursore");
		acapo1.setTooltip(acapo_tip);acapo2.setTooltip(acapo_tip);
		acapo1.setOnMouseClicked(e -> 
		{	testoc.replaceSelection("<br>");
			testoc.requestFocus();
		});
		acapo2.setOnMouseClicked(e -> 
		{	appro_text.replaceSelection("<br>");
			appro_text.requestFocus();
		});		
		annulla=new Button("annulla");
      	Tooltip annulla_tip=new Tooltip("annulla l' ultima cella creata");	
      	annulla.setTooltip(annulla_tip);
      	annulla.setOnMouseClicked(e ->
      	{	if(geco==0)
			{	showAlert("Attenzione!Non ci sono processi da annullare!");
				return;					
			}
			if(sfondoc.getText()==""||sfondoc.getText()==null||sfondoc.getText().length()==0)
			{	showAlert("Attenzione!Si può annullare solo l' ultima cella aggiunta!");
				return;					
			}
			int beta=cell_names.size()-1;
			int x=numeroc.getSelectionModel().getSelectedIndex()-1;
			int y=numeror.getSelectionModel().getSelectedIndex()-1;
			gPanel.getChildren().remove(cellB.get(y).get(x));
			sfondoc.setText("");
			testoc.setText("");
			cell_names.remove(beta);
			cell_text.remove(beta);
			cell_row.remove(beta);
			cell_span_row.remove(beta);
			cell_col.remove(beta);
			cell_span_col.remove(beta);
			cell_style.remove(beta);
			cell_appro.remove(beta);
			cell_audio.remove(beta);			
			cell_web.remove(beta); 
			appro_web.remove(beta);
			geco--;
      	});
      	anteprima=new Button("anteprima");
      	anteprima.setOnMouseClicked(e -> 
		{	String n = nome.getText();
			String m = materia.getText();
			String p = autore.getText();			
			if(n==""||n==null||n.length()==0)
			{	showAlert("Attenzione! Scegli un nome per la mappa che stai creando!");
				nome.requestFocus();
				return;
			}
			if(m==""||m==null||m.length()==0)
			{	showAlert("Attenzione! Indica la materia a cui la mappa si riferisce!");
				materia.requestFocus();
				return;
			}
			if(p==""||p==null||p.length()==0)
			{	showAlert("Attenzione! Indica l' autore della mappa!");
				autore.requestFocus();
				return;
			}
			if(n_cols.getSelectionModel().getSelectedItem()=="colonne")
			{	showAlert("Attenzione! Per creare la mappa devi indicare quante colonne deve avere!");
				n_cols.requestFocus();
				return;
			}
			if(n_rows.getSelectionModel().getSelectedItem()=="righe")
			{	showAlert("Attenzione! Per creare la mappa devi indicare quante righe deve avere!");
				n_rows.requestFocus();
				return;
			}
			else
			{	nomec.setText(nome.getText().replaceAll(" ", "_"));
				nomec.setEditable(false);
				int a=Integer.parseInt(n_cols.getSelectionModel().getSelectedItem());
				int b=Integer.parseInt(n_rows.getSelectionModel().getSelectedItem());
				cell_names=new ArrayList<String>(b);
				cell_text=new ArrayList<String>(b);
				cell_row=new ArrayList<Integer>(b);
				cell_span_row=new ArrayList<Integer>(b);
				cell_col=new ArrayList<Integer>(b);
				cell_span_col=new ArrayList<Integer>(b);
				cell_style=new ArrayList<String>(b);
				cell_appro=new ArrayList<String>(b);
				cell_audio=new ArrayList<String>(b);
				cell_web=new ArrayList<String>(b);
				appro_web=new ArrayList<String>(b);
				cellB=new ArrayList<ArrayList<Button>>(b);
				for(int r=0;r<b;r++)
				{	cellB.add(new ArrayList<Button>(a));
				}
				rPanel=new GridPane();
				rPanel.setAlignment(Pos.BASELINE_CENTER);
				gPanel=new GridPane();gPanel.setPadding(new Insets(2,10,2,10));
				gPanel.setHgap(5);gPanel.setVgap(5);
				gPanel.setAlignment(Pos.BASELINE_CENTER);
				ColumnConstraints cc=new ColumnConstraints();
				cc.setPercentWidth(100/a);
				for(int i=0;i<a;i++)
				{ 	rPanel.getColumnConstraints().add(cc);
					gPanel.getColumnConstraints().add(cc);
				}
				RowConstraints rc=new RowConstraints();
				rc.setPercentHeight(100/b);
				for(int i=0;i<b;i++)
				{ 	rPanel.getRowConstraints().add(rc);
					gPanel.getRowConstraints().add(rc);
				}
				for(int k=0;k<b;k++)
				{	for(int h=0;h<a;h++)
					{	Button button=new Button();
						button.setText((h+1)+"-"+(k+1));
						button.getStyleClass().clear();
						button.setId("r2button");
						button.setMinWidth(40);
						button.setMaxWidth(90);
						button.setMinHeight(30);
						button.setPrefHeight(30);
						button.setMaxHeight(60);
						button.setAlignment(Pos.BASELINE_CENTER);
						button.setPadding(new Insets(5,5,5,5));
						gPanel.add(button,h,k);
						cellB.get(k).add(button);
					}
				}
				borderPane.setCenter(gPanel);
				Path path=Paths.get(System.getProperty("user.dir")+"/mappe/"+nome.getText());
				Path code=Paths.get(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/code");
				Path font=Paths.get(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/font");
				Path imgs=Paths.get(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/imgs");
				Path audio=Paths.get(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/audio");
				try 
				{	Files.createDirectories(path);
					Files.createDirectories(code);
					Files.createDirectories(font);
					Files.createDirectories(imgs);
					Files.createDirectories(audio);
				} 
				catch (IOException e1) 
				{	// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				File ffont=new File(System.getProperty("user.dir")+"/font/Montserrat-Regular.ttf");
				codice=new File(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/code/codice.js");
				stile=new File(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/code/stile.css");
				webPage=new File(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/"+nome.getText()+".html");
				FileInputStream in;
				FileOutputStream out;
				try 
				{	in = new FileInputStream(ffont);
					out = new FileOutputStream(new File(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/font/Montserrat-Regular.ttf"));
					while (in.available() != 0) 
			        { //finche' ci sono dati disponibili in input
						out.write(in.read()); //leggi e scrivi
						codice.createNewFile();
						stile.createNewFile();
						webPage.createNewFile();
			        }
					in.close();
			        out.close();
				} 
				catch (FileNotFoundException e2) 
				{	// TODO Auto-generated catch block
					e2.printStackTrace();
				} 
				catch (IOException e3) 
				{	// TODO Auto-generated catch block
					e3.printStackTrace();
				}						
			
			}
			nome.setEditable(false);
			materia.setEditable(false);
			autore.setEditable(false);
			n_cols.setDisable(true);
			n_rows.setDisable(true);
			
		});
      	Tooltip ante_tip=new Tooltip("anteprima dell' immagine della mappa");	
		anteprima.setTooltip(ante_tip);
		apri=new Button("apri");
		Tooltip apri_tip=new Tooltip("apre la mappa interattiva creata");
		apri.setTooltip(apri_tip);
		apri.setOnMouseClicked(e ->
		{	String babba=nome.getText();
			File t=new File("mappe/"+babba+"/"+babba+".html");
			if(nome.getText().length()==0)
			{	showAlert("Attenzione! Non hai ancora creato la mappa!");
				return;
			}
			if(t.exists()==false)
			{	showAlert("Attenzione! Il file non esiste! Forse non hai ancora salvato?");	
				return;
			}
			else
			{	HostServices billo = getHostServices();
				billo.showDocument(t.toURI().toString());	
			}
		});
		
		colorec=new Button("sfondo cella");
		Tooltip colorec_tip=new Tooltip("scegli il colore di sfondo per la cella");
		colorec.setTooltip(colorec_tip);
		colorec.setOnMouseClicked(e -> 
		{   Stage k = new Stage();
    		colorPicker q = new colorPicker();
    		q.start(k);            
		} );
		crea_cella=new Button("crea cella ->");
		Tooltip creac_tip=new Tooltip("crea una nuova cella che si può vedere nelle anteprime");
		crea_cella.setTooltip(creac_tip);
		crea_cella.setOnMouseClicked(e->
		{	int a=n_cols.getSelectionModel().getSelectedIndex()+8;
			int b=n_rows.getSelectionModel().getSelectedIndex()+4;
			if(nomec.getText()==""||nomec.getText()==null||nomec.getText().length()==0)
			{	showAlert("Attenzione! Scegli un nome per la cella che stai creando!");
				nomec.requestFocus();
				return;
			}
			for(int r=0;r<cell_names.size();r++)
			{	if(nomec.getText().equals(cell_names.get(r)))
				{	showAlert("Attenzione! Questo nome è già stato usato, scegli un nome unico per ogni cella!");
					nomec.requestFocus();
					return;
				}					
			}
			if(testoc.getText()==""||testoc.getText()==null||testoc.getText().length()==0)
			{	showAlert("Attenzione! Scegli il testo per la cella che stai creando!");
				testoc.requestFocus();
				return;
			}
			if(alli_combo.getSelectionModel().getSelectedIndex()==0)
			{	showAlert("Attenzione! Come allineare il testo?");
				alli_combo.requestFocus();	
				return;					
			}
			if(sfondoc.getText().length()==0)
			{	showAlert("Attenzione! Scegli un colore per la cella che stai creando!");
				colorec.requestFocus();
				return;
			}
			if(numeror.getSelectionModel().getSelectedIndex()==0)
			{	showAlert("Attenzione! In quale riga vuoi mettere la cella?");
				numeror.requestFocus();	
				return;					
			}
			if(numeroc.getSelectionModel().getSelectedIndex()==0)
			{	showAlert("Attenzione! In quale colonna vuoi mettere la cella?");
				numeroc.requestFocus();	
				return;					
			}
			if(span_row.getSelectionModel().getSelectedIndex()==0)
			{	showAlert("Attenzione! Quante righe deve occupare la cella?");
				numeroc.requestFocus();	
				return;					
			}
			if(span_col.getSelectionModel().getSelectedIndex()==0)
			{	showAlert("Attenzione! Quante colonne deve occupare la cella?");
				numeroc.requestFocus();	
				return;					
			}
			if(numeror.getSelectionModel().getSelectedIndex()+span_row.getSelectionModel().getSelectedIndex()>b)
			{	showAlert("Attenzione! La cella occupa troppe righe!");
				span_row.requestFocus();	
				return;
			}
			if(numeroc.getSelectionModel().getSelectedIndex()+span_col.getSelectionModel().getSelectedIndex()>a)
			{	showAlert("Attenzione! La cella occupa troppe colonne!");
				numeroc.requestFocus();
				return;
			}
			if(appro.getSelectionModel().getSelectedIndex()==0&&geco!=0)
			{	showAlert("Attenzione! Scegli se collegare o meno una finestra di approfondimento alla cella!");
				appro.requestFocus();	
				return;					
			}
			if(appro.getSelectionModel().getSelectedIndex()==2&&finestra_dxsx.getSelectionModel().getSelectedIndex()==0)
			{	showAlert("Attenzione! La finestra di approfondimento allineata a dx (cella a sinistra) o a sx (cella a destra)?");
				appro.requestFocus();	
				return;					
			}
			if(appro.getSelectionModel().getSelectedIndex()==2&&appro_text.getText().length()==0)
			{	showAlert("Attenzione! Non hai digitato il testo di approfondimento!");
				appro.requestFocus();	
				return;					
			}	
			if(appro.getSelectionModel().getSelectedIndex()==2&&titolo.getText().length()==0)
			{	showAlert("Attenzione! Non hai digitato il titolo della finestra di approfondimento!");
				titolo.requestFocus();	
				return;					
			}	
			int x=numeroc.getSelectionModel().getSelectedIndex()-1;
			int y=numeror.getSelectionModel().getSelectedIndex()-1;
			int xs=x+span_col.getSelectionModel().getSelectedIndex()-1;
			int ys=y+span_row.getSelectionModel().getSelectedIndex()-1;	
			int number=cell_names.size();								
			for(int w=0;w<number;w++)
			{	int x1=cell_col.get(w)-1;
				int x2=(cell_col.get(w)-1)+(cell_span_col.get(w)-1);
				int y1=cell_row.get(w)-1;
				int y2=(cell_row.get(w)-1)+(cell_span_row.get(w)-1);					
				if(x==x1&&y==y1)
				{	showAlert("Attenzione! La cella si sovrappone ad un' altra, cambiane la posizione!");
					numeror.requestFocus();	
					return;							
				}	
				if(x>=x1&&x<=x2&&y>=y1&&y<=y2)
				{	showAlert("Attenzione! La cella si sovrappone ad un' altra, cambiane la posizione!");
					numeror.requestFocus();	
					return;							
				}
				if(xs>=x1&&xs<=x2&&ys>=y1&&ys<=y2)
				{	showAlert("Attenzione! La cella si sovrappone ad un' altra, cambiane la posizione!");
					numeror.requestFocus();	
					return;							
				}
				if(x>=x1&&x<=x2&&ys>=y1&&ys<=y2)
				{	showAlert("Attenzione! La cella si sovrappone ad un' altra, cambiane la posizione!");
					numeror.requestFocus();	
					return;							
				}
				if(xs>=x1&&xs<=x2&&y>=y1&&y<=y2)
				{	showAlert("Attenzione! La cella si sovrappone ad un' altra, cambiane la posizione!");
					numeror.requestFocus();	
					return;							
				}
			}
			if(span_col.getSelectionModel().getSelectedIndex()==1&&span_row.getSelectionModel().getSelectedIndex()==1)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}															
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.getChildren().add(cellB.get(y).get(x));	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==1&&span_row.getSelectionModel().getSelectedIndex()==2)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,1,2);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==1&&span_row.getSelectionModel().getSelectedIndex()==3)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,1,3);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==1&&span_row.getSelectionModel().getSelectedIndex()==4)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+";grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+3).get(x));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,1,4);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==2&&span_row.getSelectionModel().getSelectedIndex()==1)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,2,1);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==2&&span_row.getSelectionModel().getSelectedIndex()==2)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,2,2);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==2&&span_row.getSelectionModel().getSelectedIndex()==3)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+1));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,2,3);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==2&&span_row.getSelectionModel().getSelectedIndex()==4)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 2;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+3).get(x));
				gPanel.getChildren().remove(cellB.get(y+3).get(x+1));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,2,4);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==3&&span_row.getSelectionModel().getSelectedIndex()==1)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,3,1);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==3&&span_row.getSelectionModel().getSelectedIndex()==2)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+2));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,3,2);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==3&&span_row.getSelectionModel().getSelectedIndex()==3)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+2));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,3,3);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==3&&span_row.getSelectionModel().getSelectedIndex()==4)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 3;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+3).get(x));
				gPanel.getChildren().remove(cellB.get(y+3).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+3).get(x+2));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,3,4);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==4&&span_row.getSelectionModel().getSelectedIndex()==1)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+";text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y).get(x+3));	
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,4,1);
				
			}
			if(span_col.getSelectionModel().getSelectedIndex()==4&&span_row.getSelectionModel().getSelectedIndex()==2)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 2;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y).get(x+3));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+3));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,4,2);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==4&&span_row.getSelectionModel().getSelectedIndex()==3)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 3;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y).get(x+3));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+3));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+3));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,4,3);	
			}
			if(span_col.getSelectionModel().getSelectedIndex()==4&&span_row.getSelectionModel().getSelectedIndex()==4)
			{	if(alli_combo.getSelectionModel().getSelectedIndex()==1)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_CENTER);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==2)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:center;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_LEFT);
				}
				if(alli_combo.getSelectionModel().getSelectedIndex()==3)
				{	cell_style.add("border:1px dashed gray;background:"+sfondoc.getText()+";grid-column:"+numeroc.getSelectionModel().getSelectedIndex()+"/span 4;grid-row:"+numeror.getSelectionModel().getSelectedIndex()+"/span 4;text-align:right;");
					cellB.get(y).get(x).setAlignment(Pos.BASELINE_RIGHT);
				}									
				cellB.get(y).get(x).setText(testoc.getText());
				cellB.get(y).get(x).getStyleClass().clear();
				cellB.get(y).get(x).setStyle("-fx-text-fill:#000080;-fx-border-color:#000080;-fx-background-color:"+sfondoc.getText()+";-fx-font-size:small;");	
				gPanel.getChildren().remove(cellB.get(y).get(x));
				gPanel.getChildren().remove(cellB.get(y).get(x+1));
				gPanel.getChildren().remove(cellB.get(y).get(x+2));
				gPanel.getChildren().remove(cellB.get(y).get(x+3));
				gPanel.getChildren().remove(cellB.get(y+1).get(x));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+1).get(x+3));
				gPanel.getChildren().remove(cellB.get(y+2).get(x));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+2).get(x+3));
				gPanel.getChildren().remove(cellB.get(y+3).get(x));
				gPanel.getChildren().remove(cellB.get(y+3).get(x+1));
				gPanel.getChildren().remove(cellB.get(y+3).get(x+2));
				gPanel.getChildren().remove(cellB.get(y+3).get(x+3));
				cellB.get(y).get(x).setMaxWidth(Double.MAX_VALUE);
				cellB.get(y).get(x).setMaxHeight(Double.MAX_VALUE);
				GridPane.setFillWidth(cellB.get(y).get(x), true);
				GridPane.setFillHeight(cellB.get(y).get(x), true);
				gPanel.add(cellB.get(y).get(x),x,y,4,4);	
			}
			if(appro.getSelectionModel().getSelectedIndex()==1)
			{	cell_appro.add("fond");
				appro_web.add("");
			}
			else if(appro.getSelectionModel().getSelectedIndex()==2)
			{	cell_appro.add(nomec.getText().replaceAll(" ","_")+"_div");
				String bibbi="";
				if(finestra_dxsx.getSelectionModel().getSelectedIndex()==1)
				{	bibbi="bibbi1";
				}
				else if(finestra_dxsx.getSelectionModel().getSelectedIndex()==2)
				{	bibbi="bibbi2";
				}
				String div_create="\n<div id=\""+nomec.getText().replaceAll(" ","_")+"_div\" class=\""+bibbi+"\">\n"
						+ "<div class=\"title\">\n"
						+ titolo.getText().toUpperCase()
						+ "\n<input type=\"image\" onclick=\"javascript:hideIt('"+nomec.getText().replaceAll(" ","_")+"_div')\" src=\"imgs/close.png\"> \n"
						+ "<input type=\"image\" onclick=\"javascript:enlargeIt('"+nomec.getText().replaceAll(" ","_")+"_div')\" src=\"imgs/enlarge.png\">\n"
						+ "</div><br><br>\n"
						+appro_text.getText()+"\r\n</div>\r\n";
				appro_web.add(div_create);
				testoc.setText(testoc.getText()+" <img src='imgs/finestra.png' style='vertical-align:bottom;' />");	
				finestra_dxsx.getSelectionModel().select(0);
			}
			cell_names.add(nomec.getText().toLowerCase().replaceAll(" ","_"));
			cell_text.add(testoc.getText().replaceAll("\n", "").replaceAll("\r", ""));			
			cell_row.add(numeror.getSelectionModel().getSelectedIndex());
			cell_span_row.add(span_row.getSelectionModel().getSelectedIndex());
			cell_col.add(numeroc.getSelectionModel().getSelectedIndex());
			cell_span_col.add(span_col.getSelectionModel().getSelectedIndex());
			cell_audio.add("audio/"+nomec.getText().replaceAll(" ","_")+".mp3");
			String div_create="";
			if(geco==0)
			{	div_create="\n<div id=\""+nomec.getText().toLowerCase().replaceAll(" ","_")+"\"  onmouseover=\"cleanButtons()\" onclick=\"showAll()\"></div>\n";
				appro.setDisable(false);appro.getSelectionModel().select(0);
			}
			else
			{	div_create="\n<div id=\""+nomec.getText().toLowerCase().replaceAll(" ","_")+"\"></div>\n";				
			}
			cell_web.add(div_create);		
			nomec.setEditable(true);
	        geco++;
		});
		immagine=new Button("immagine");
		Tooltip immagine_tip=new Tooltip("aggiunge una o più immagini alla finestra di approfondimento");
		immagine.setTooltip(immagine_tip);
		immagine.setOnMouseClicked(e -> 
		{	if(nomec.getText()==""||nomec.getText().length()==0)
			{	showAlert("Attenzione! non hai ancora dato un nome alla cella!");
				nomec.requestFocus();
				return;				
			}
			if(testoc.getText()==""||testoc.getText().length()==0)
			{	showAlert("Attenzione! non hai ancora dato un nome alla cella!");
				testoc.requestFocus();
				return;				
			}
			if(appro_text.getText()==""||appro_text.getText().length()==0)
			{	showAlert("Attenzione! Aggiungi il testo della finestra di approfondimento, poi l' immagine!");
				appro_text.requestFocus();
				return;				
			}
			String currentD = System.getProperty("user.dir");
			chooser = new FileChooser();
			chooser.setTitle("seleziona l' immagine");
			File j = null;
			try
			{	j = chooser.showOpenDialog(primaryStage);
				FileInputStream in1 = new FileInputStream(j);
		        /* Apri uno stream di output */
		        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/mappe/"+nome.getText()+"/imgs", j.getName()));
		        while (in1.available() != 0) 
		        { //finche' ci sono dati disponibili in input
		          out1.write(in1.read()); //leggi e scrivi
		        }
		        in1.close();
		        out1.close();
			}
			catch (Exception b)
			{	System.out.println(b.toString());					
			}
			String st=appro_text.getText();
			String img_path="<img src=\"imgs/"+j.getName()+"\" />";
			appro_text.setText(img_path+st);
		});
		grassetto1=new Button("grassetto");
		Tooltip grassetto_tip=new Tooltip("seleziona il testo poi premi il pulsante perchè diventi in grassetto");
		grassetto1.setTooltip(grassetto_tip);
		grassetto2=new Button("grassetto");
		grassetto2.setTooltip(grassetto_tip);
		grassetto1.setOnMouseClicked(e -> 
		{	String y=testoc.getSelectedText();
			if(y==""||y==null||y.length()==0)
			{	showAlert("Attenzione! Seleziona il testo che vuoi proporre in grassetto!");
				return;					
			}	
			else
			{	testoc.replaceSelection("<b>"+y+"</b>");
				testoc.requestFocus();
				
			}
		});
		grassetto2.setOnMouseClicked(e -> 
		{	String y=appro_text.getSelectedText();
			if(y==""||y==null||y.length()==0)
			{	showAlert("Attenzione! Seleziona il testo che vuoi proporre in grassetto!");
				return;					
			}	
			else
			{	appro_text.replaceSelection("<b>"+y+"</b>");
				appro_text.requestFocus();
				
			}
		});
		pulisci=new Button("pulisci");
		Tooltip pulisci_tip=new Tooltip("pulisce i campi di testo del pannello a sinistra");
		pulisci.setTooltip(pulisci_tip);
		pulisci.setOnMouseClicked(e -> 
		{	nomec.setText("");
			testoc.setText("");
			appro_text.setText("");
			titolo.setText("");
			nomec.requestFocus();
		});
		reset=new Button("rifai da capo");
		Tooltip reset_tip=new Tooltip("cancella tutti i dati inseriti e permette di creare una nuova mappa");
		reset.setTooltip(reset_tip);
		reset.setOnMouseClicked(e -> 
		{	nome.setText("");
			nome.setEditable(true);
			if(nomec.getText()!=null)
			nomec.setText("");
			nomec.setEditable(true);
			numeroc.setDisable(false);
			numeror.setDisable(false);
			materia.setText("");
			materia.setEditable(true);
			autore.setText("");
			autore.setEditable(true);
			if(testoc.getText()!=null)
			testoc.setText("");
			if(appro_text.getText()!=null)
			appro_text.setText("");
			appro.setDisable(true);
			gPanel.getChildren().clear();
			GridPane.clearConstraints(gPanel);
			n_cols.getSelectionModel().clearAndSelect(0);
			n_cols.setDisable(false);
			n_rows.getSelectionModel().clearAndSelect(0);
			n_rows.setDisable(false);
			cellB.clear();
			cell_names.clear();
			cell_text.clear();
			cell_style.clear();
			cell_row.clear();
			cell_span_row.clear();
			cell_col.clear();
			cell_span_col.clear();
			cell_appro.clear();
			cell_audio.clear();
			geco=0;
			nome.requestFocus();
		});		
		salva=new Button("salva");
		Tooltip salva_tip=new Tooltip("salva tutti i dati e crea la mappa interattiva");
		salva.setTooltip(salva_tip);
		salva.setOnMouseClicked(e->
		{	if(nome.getText()==""||nome.getText()==null||nome.getText().length()==0)
			{	showAlert("Attenzione! Non hai ancora creato la mappa!");
				nome.requestFocus();
				return;
			}
			if(cell_names.size()==0)
			{	showAlert("Attenzione! non hai ancora creato celle!");
				nomec.requestFocus();
				return;
			}			
			String mat=materia.getText().replaceAll("<", "").replaceAll(">", "");
			String aut=autore.getText().replaceAll("<", "").replaceAll(">", "");
			String web_start="<!DOCTYPE html>\n"+
				"<html>\n"+
				"<head>\n"+
				"<meta charset=\"UTF-8\">\n"+
				"<title>"+nome.getText()+"</title>\n"+
				"<script src=\"code/codice.js\"></script>\n"+
				"<link rel=\"stylesheet\" href=\"code/stile.css\">\n"+
				"</head>\n<body>\n"+
				"<div class=\"header\">\n"+
				"<div>\n<button onclick=\"javascript:window.location.href='https://www.youtube.com/channel/UCsOehirwvU56jrF7eKDLY1w?sub_confirmation=1'\">\n"+
				"mappe interattive</button>\n</div>\n"+
				"<div>"+mat+"</div>\n<div>"+aut+"</div>\n</div>\n"+
				"<div id=\"sound\"></div>\n";
			for(int d=0;d<cell_names.size();d++)
			{	web_start=web_start+appro_web.get(d);				
			}
			String cdiv="<div class=\"cdiv\">\n";
			for(int d=0;d<cell_names.size();d++)
			{	cdiv=cdiv+cell_web.get(d);				
			}
			String fond="\n<div id=\"fond\"></div>\n";
			cdiv=cdiv+fond;
			String web_end="</div>\n</body>\n</html>";			
			try 
			{ 	FileWriter web_writer = new FileWriter(webPage);
				BufferedWriter web_buffer = new BufferedWriter(web_writer);
				PrintWriter web_printer = new PrintWriter(web_buffer);
				web_printer.print(web_start+cdiv+web_end);	
				web_printer.close();
			}
			catch (Exception evt)
			{	System.out.println(evt.toString());	
			}
			String css=
					"@charset \"UTF-8\";\n"
					+ "@font-face \n"
					+ "{ font-family: 'Montserrat';\n"
					+ "  src: url('../font/Montserrat-Regular.ttf');\n"
					+ "}"
					+"body, button\n"
					+ "{ font-family:Montserrat;font-size:large;border-radius:5px;color:black;	\n"
					+ "}\n"
					+"table\n"
					+"{border-spacing: 5px;box-sizing:border-box;}\n"
					+"td,th \n"
					+"{border:1px dotted gray;border-radius:3px;padding:5px;box-sizing:border-box;}\n"
					+"#"+cell_names.get(0)+"\n"
					+ "{	font-size:large;\n"
					+ "  	font-weight:bold;\n"
					+ "}"
					+".header\n"
					+ "{	position:absolute;\n"
					+ "	top:1%;\n"
					+ "	left:0%;\n"
					+ "	width:100%;\n"
					+ "	height:10%;\n"
					+ "	display:grid;\n"
					+ "	grid-template-columns:repeat(3,1fr);\n"
					+ "	grid-template-rows: 1fr;\n"
					+ "	text-align:center;\n"
					+ "	font-size:large;\n"
					+ "	box-sizing:border-box;\n"
					+ "}\n"
					+".cdiv\n"
					+ "{	position:absolute;\n"
					+ "	top:10%;\n"
					+ "	left:0%;\n"
					+ "	width:100%;\n"
					+ "	display:grid;\n"
					+ "	grid-template-columns: repeat("+(n_cols.getSelectionModel().getSelectedIndex()+7)+",1fr);\n"
					+ "	grid-template-rows: auto 1fr auto;\n"
					+ "	grid-gap:30px;\n"
					+ "	background:transparent;\n"
					+ " opacity:1;\n"
					+ "	padding:10px;\n"
					+ "	box-sizing:border-box;	\n"
					+ "	cursor:pointer;\n"
					+ "}\n"
					+ ".cdiv div\n"
					+ "{	border-width:0px;\n"
					+ "	border-radius:5px;\n"
					+ "	height:auto;\n"
					+ "	min-height:30px;\n"
					+ "	max-height:800px;\n"
					+ "	box-sizing:border-box;\n"
					+ "	text-align:center;\n"
					+ "	overflow:auto;\n"
					+ "	font-size:medium;\n"
					+ "	padding:3px;\n"
					+ "}\n"
					+ ".title\n"
					+ "{  	background:#eeeeee;\n"
					+ "	opacity:0.9;\n"
					+ "	position: -webkit-sticky;\n"
					+ " position: sticky;\n"
					+ "	top: 0;\n"
					+ "	left:25%;\n"
					+ "	width:50%;\n"
					+ "	height:4%;\n"
					+ "	font-weight:bold;\n"
					+ "	border-radius:5px;\n"
					+ "	border-style:dotted;\n"
					+ "	border-width:1px;\n"
					+ "	border-color:#283544;\n"
					+ "	padding:3px;\n"
					+ "	text-align:center;\n"
					+ "}\n"
					+".bibbi1\n"
					+ "{	background:white;\n"
					+ "	display:none;\n"
					+ "	position:absolute;\n"
					+ "	top:20%;\n"
					+ "	left:1%;\n"
					+ "	width:48%;\n"
					+ "	height:auto;\n"
					+ "	max-height:70%;\n"
					+ "	padding:5px;\n"
					+ "	overflow:auto;\n"
					+ "	box-sizing: border-box;\n"
					+ "	border-radius:5px;\n"
					+ "	border-style:solid;\n"
					+ "	border-width:1px;\n"
					+ "	border-color:#283544;\n"
					+ "	box-shadow: 5px 5px #cccccc;\n"
					+ " z-index:2;\n"
					+ "}\n"
					+ ".bibbi2\n"
					+ "{	background:white;\n"
					+ "	display:none;\n"
					+ "	position:absolute;\n"
					+ "	top:20%;\n"
					+ "	left:51%;\n"
					+ "	width:48%;\n"
					+ "	height:auto;\n"
					+ "	max-height:70%;\n"
					+ "	padding:5px;\n"
					+ "	overflow:auto;\n"
					+ "	box-sizing: border-box;\n"
					+ "	border-radius:5px;\n"
					+ "	border-style:solid;\n"
					+ "	border-width:1px;\n"
					+ "	border-color:#283544;\n"
					+ "	box-shadow: 5px 5px #cccccc;\n"
					+ " z-index:2;\n"
					+ "}"
					+".bibbi1 img\n"
					+ "{	float:right;\n"
					+ "	margin:20px;\n"
					+ "    width:50%;\n"
					+ "    border-radius:5px;\n"
					+ "}\n"
					+ ".bibbi2 img\n"
					+ "{	float:left;\n"
					+ "	margin:20px;\n"
					+ "    width:50%;\n"
					+ "    border-radius:5px;\n"
					+ "}\n"
					+"@media only screen and (max-width:1500px)\n"
					+ "{	body, div, button\n"
					+ "	{	font-size:small;	\n"
					+ "	}\n"
					+ "	.cdiv \n"
					+ "    {	font-size:small;\n"
					+ "    	padding:2px;\n"
					+ "      	grid-gap:3px;\n"
					+ "    }\n"
					+ "    .cdiv div\n"
					+ "    {	font-size:small;\n"
					+ "        padding:1px;  \n"
					+ "        height:20px;      \n"
					+ "    }\n"
					+ "  	.header\n"
					+ "  	{	font-size:small;\n"
					+ "  		height:4% ;\n"
					+ "        padding:1px;    \n"
					+ "  	}\n"
					+ "  	.bibbi1,.bibbi2\n"
					+ "  	{	font-size:small;\n"
					+ "  		padding:1px;\n"
					+ "  	}\n"
					+ "  	.bibbi1,.bibbi2 img\n"
					+ "  	{	margin:3px;\n"
					+ "  	}\n"
					+ "  	#"+nome.getText()+"\n"
					+ "  	{	font-size:small;\n"
					+ "  		font-weight:normal;\n"
					+ "  	}  \n"
					+ "}\n"
					+ "@media only screen and (max-width:1100px)\n"
					+ "{	body, div, button\n"
					+ "	{	font-size:x-small;	\n"
					+ "	}\n"
					+ "	.cdiv \n"
					+ "    {	font-size:x-small;\n"
					+ "    	padding:1px;\n"
					+ "      	grid-gap:1px;      	\n"
					+ "    }\n"
					+ "    .cdiv div\n"
					+ "    {	font-size:x-small;\n"
					+ "        padding:1px;\n"
					+ "        height:15px;\n"
					+ "        \n"
					+ "    }\n"
					+ "  	.header\n"
					+ "  	{	font-size:x-small;\n"
					+ "  		height:4% ;\n"
					+ "        padding:1px;    \n"
					+ "  	}\n"
					+ "  	.bibbi1,.bibbi2\n"
					+ "  	{	font-size:x-small;\n"
					+ "  		padding:1px;\n"
					+ "  	}\n"
					+ "  	#"+nome.getText()+"\n"
					+ "  	{	font-size:x-small;\n"
					+ "  		font-weight:normal;\n"
					+ "  	}  \n"
					+ "}";
			try 
			{ 	FileWriter style_writer = new FileWriter(stile);
				BufferedWriter style_buffer = new BufferedWriter(style_writer);
				PrintWriter style_printer = new PrintWriter(style_buffer);
				style_printer.print(css);	
				style_printer.close();
			}
			catch (Exception evt)
			{	System.out.println(e.toString());	
			}
			String js="var cells=\n[\n";
			int b=cell_names.size();
			for(int k=0;k<b;k++)
			{	js=js+"[\""+cell_names.get(k).toLowerCase()+"\",\""+cell_text.get(k)+"\",\""+cell_style.get(k)+"\",\""+cell_appro.get(k)+"\",\""+cell_audio.get(k)+"\"],\n";
			}
			js=js+"[\"fond\",\"\",\"border-width:0px;background:#ffffff\",\"fond\",\"\"],\n";
			js=js+"];\n";
			js=js+
			"var len = cells.length;	\n"
			+ "function cleanButtons()\n"
			+ "{	let y=document.getElementById(cells[0][0]);\n"
			+ "	let h=document.getElementById(cells[1][0]);\n"
			+ "	for (let b=0;b<len;b++)\n"
			+ "	{	document.getElementById(cells[b][0]).style.background=\"white\";\n"
			+ "		document.getElementById(cells[b][0]).innerHTML=\"\";\n"
			+ "	}\n"
			+ "	y.style.background=\"#dddddd\";\n"
			+ "	y.style.boxShadow=\"10px 10px 10px 10px lightgray\";\n"
			+ "	h.style.border=\"1px dashed gray\";\n"
			+ "	document.getElementById(\"fond\").style.display=\"none\";\n"
			+ "}	\n"
			+ "function showAll()\n"
			+ "{	for(let i=0;i<len;i++)\n"
			+ "	{	let k = document.getElementById(cells[i][0]);\n"
			+ "		k.style=cells[i][2];\n"
			+ "		k.innerHTML=cells[i][1];				\n"
			+ "	}	\n"
			+ "	document.getElementById(\"fond\").style.display=\"none\";	\n"
			+ "}\n"
			+"window.onload = function ()\n"
			+ "{	for (let g=1;g<len;g++)\n"
			+ "	{	let k=document.getElementById(cells[g][0]);\n"
			+ "		k.style=cells[g][2];\n"
			+ "		k.style.background=\"#ffffff\";\n"
			+ "	}\n"
			+ "	document.getElementById(\"fond\").style.border=\"0px solid white\";\n"
			+ "	document.getElementById(\""+cell_names.get(0)+"\").innerHTML=cells[0][1];\n"
			+ "	document.getElementById(\""+cell_names.get(0)+"\").style=cells[0][2];\n"
			+ "	document.addEventListener(\"mouseover\",eventOver);	\n"
			+ "	function eventOver(e)\n"
			+ "	{	for(let i=0;i<len;i++)\n"
			+ "		{	let k = document.getElementById(cells[i][0]);\n"
			+ "			if (k==e.target)\n"
			+ "			{	k.style=cells[i][2];\n"
			+ "				k.style.borderWidth=\"0px\";\n"
			+ "				k.style.boxShadow=\"10px 10px 10px 10px lightgray\";	\n"
			+ "				k.innerHTML=cells[i][1];\n"
			+ "				document.getElementById(cells[i+1][0]).style=cells[i+1][2];\n"
			+ "				document.getElementById(\"fond\").style.display=\"none\";\n"
			+ "				displayAudio(cells[i][4]);\n"
			+ "			}			\n"
			+ "		}		\n"
			+ "	}\n"
			+ "	document.addEventListener(\"mouseout\",eventOut);	\n"
			+ "	function eventOut(e)\n"
			+ "	{	for(let i=0;i<len;i++)\n"
			+ "		{	let k = document.getElementById(cells[i][0]);\n"
			+ "			if (k==e.target)\n"
			+ "			{	k.style=cells[i][2];\n"
			+ "				k.style.boxShadow=\"0px 0px 0px 0px gray\";\n"
			+ "				document.getElementById(cells[i+1][0]).style.border=\"1px dashed gray\";\n"
			+ "			}	\n"
			+ "		}		\n"
			+ "	}\n"
			+ "	document.addEventListener(\"click\",eventClick);	\n"
			+ "	function eventClick(e)\n"
			+ "	{	for(let i=1;i<len;i++)\n"
			+ "		{	let k = document.getElementById(cells[i][0]);\n"
			+ "			if (k==e.target)\n"
			+ "			{	if (document.getElementById(cells[i][3]).style.display==\"block\")\n"
			+ "				{	document.getElementById(cells[i][3]).style.display=\"none\";\n"
			+ "				}\n"
			+ "				else\n"
			+ "				{	document.getElementById(cells[i][3]).style.display=\"block\"\n"
			+ "				}\n"
			+ "			}\n"
			+ "		}	\n"
			+ "		document.getElementById(\"fond\").style.display=\"none\";	\n"
			+ "	}\n"
			+ "return;\n}\n"
			+"function displayAudio(audio)\n"
			+ "{	let blob=\"<audio controls autoplay hidden>\"+\n"
			+ "	\"<source src='\"+audio+\"' type='audio/ogg'>\"+\n"
			+ "	\"<source src='\"+audio+\"' type='audio/mpeg'>\"+	\n"
			+ "	\"Your browser does not support the audio element.</audio>\";\n"
			+ "	document.getElementById(\"sound\").innerHTML=blob;	\n"
			+ "}\n"
			+"let dim = false;\n"
			+ "const BIBBI_WIDTH = \"48%\";\n"
			+ "const BIBBI_TOP = \"20%\"\n"
			+ "const BIBBI1_LEFT = \"1%\";\n"
			+ "const BIBBI2_LEFT = \"51%\";\n"
			+ "const BIBBI_MAX_HEIGTH = \"70%\";\n"
			+ "const BIBBI_ENLARGE_WIDTH = \"98%\";\n"
			+ "const BIBBI_ENLARGE_HEIGTH = \"85%\";\n"
			+ "const BIBBI_ENLARGE_TOP = \"10%\";\n"
			+ "function hideIt(qc)\n"
			+ "{   let bibbis1=document.getElementsByClassName(\"bibbi1\");\n"
			+ "    let k=bibbis1.length;\n"
			+ "    let bibbis2=document.getElementsByClassName(\"bibbi2\");\n"
			+ "    let h=bibbis2.length;\n"
			+ "    for(let a=0;a<k;a++)\n"
			+ "    {	bibbis1[a].style.display=\"none\";\n"
			+ "    }\n"
			+ "    for(let b=0;b<h;b++)\n"
			+ "    {	bibbis2[b].style.display=\"none\";\n"
			+ "    }\n"
			+ "	\n"
			+ "	if(document.getElementById(qc).getAttribute('class')==\"bibbi1\")\n"
			+ "    {	document.getElementById(qc).style.top = BIBBI_TOP;\n"
			+ "		document.getElementById(qc).style.left = BIBBI1_LEFT;\n"
			+ "	    document.getElementById(qc).style.width = BIBBI_WIDTH;\n"
			+ "	    document.getElementById(qc).style.maxHeight = BIBBI_MAX_HEIGTH;\n"
			+ "	}\n"
			+ "    else\n"
			+ "    {	document.getElementById(qc).style.top = BIBBI_TOP;\n"
			+ "		document.getElementById(qc).style.left = BIBBI2_LEFT;\n"
			+ "    	document.getElementById(qc).style.width = BIBBI_WIDTH;\n"
			+ "    	document.getElementById(qc).style.maxHeight = BIBBI_MAX_HEIGTH;\n"
			+ "    }\n"
			+ "	document.getElementById(qc).style.display = \"none\";\n"
			+ "	dim=false;	\n"
			+ "}\n"
			+ "function enlargeIt(div)\n"
			+ "{	if(dim==true)\n"
			+ "	{	if(document.getElementById(div).getAttribute(\"class\")==\"bibbi1\")\n"
			+ "		{	document.getElementById(div).style.width=BIBBI_WIDTH;\n"
			+ "			document.getElementById(div).style.height=\"auto\";\n"
			+ "			document.getElementById(div).style.left=BIBBI1_LEFT;\n"
			+ "			document.getElementById(div).style.top=BIBBI_TOP;\n"
			+ "		  	document.getElementById(div).style.maxHeight=BIBBI_MAX_HEIGTH;\n"
			+ "			dim=false;\n"
			+ "		}\n"
			+ "		else if(document.getElementById(div).getAttribute(\"class\")==\"bibbi2\") \n"
			+ "		{	document.getElementById(div).style.width=BIBBI_WIDTH;\n"
			+ "			document.getElementById(div).style.height=\"auto\";\n"
			+ "			document.getElementById(div).style.left=BIBBI2_LEFT;\n"
			+ "			document.getElementById(div).style.top=BIBBI_TOP;\n"
			+ "		  	document.getElementById(div).style.maxHeight=BIBBI_MAX_HEIGTH;\n"
			+ "			dim=false;\n"
			+ "		}\n"
			+ "	}\n"
			+ "	else if(dim==false)\n"
			+ "	{	document.getElementById(div).style.width=BIBBI_ENLARGE_WIDTH;\n"
			+ "		document.getElementById(div).style.height=\"auto\";\n"
			+ "		document.getElementById(div).style.left=BIBBI1_LEFT;\n"
			+ "		document.getElementById(div).style.top=BIBBI_ENLARGE_TOP;\n"
			+ "		document.getElementById(div).style.maxHeight=BIBBI_ENLARGE_HEIGTH;\n"
			+ "		dim=true;\n"
			+ "	}		\n"
			+ "}";
			try 
			{ 	FileWriter js_writer = new FileWriter(codice);
				BufferedWriter js_buffer = new BufferedWriter(js_writer);
				PrintWriter js_printer = new PrintWriter(js_buffer);
				js_printer.print(js);	
				js_printer.close();
			}
			catch (Exception evt)
			{	System.out.println(e.toString());	
			}
			close=new File("imgs/close.png");
			enlarge=new File("imgs/enlarge.png");
			finestra=new File("imgs/finestra.png");
			String currentD = System.getProperty("user.dir");
			try
			{	FileInputStream in1 = new FileInputStream(close);
				FileInputStream in2 = new FileInputStream(enlarge);
				FileInputStream in3 = new FileInputStream(finestra);
		        /* Apri uno stream di output */
		        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/mappe/"+nome.getText()+"/imgs", close.getName()));
		        FileOutputStream out2 = new FileOutputStream(new File(currentD+"/mappe/"+nome.getText()+"/imgs", enlarge.getName()));
		        FileOutputStream out3 = new FileOutputStream(new File(currentD+"/mappe/"+nome.getText()+"/imgs", finestra.getName()));
		        while (in1.available() != 0) 
		        { //finche' ci sono dati disponibili in input
		          out1.write(in1.read()); //leggi e scrivi
		        }
		        while (in2.available() != 0) 
		        { //finche' ci sono dati disponibili in input
		          out2.write(in2.read()); //leggi e scrivi
		        }	
		        while (in3.available() != 0) 
		        { //finche' ci sono dati disponibili in input
		          out3.write(in3.read()); //leggi e scrivi
		        }	
		        in1.close();in2.close();in3.close();
		        out1.close();out2.close();out3.close();
		    }
			catch (Exception evt)
			{	System.out.println(evt.toString());					
			}
			for(int d=0;d<cell_names.size();d++)
			{	if(cell_names.get(d)!=null)
				{	File h=new File(System.getProperty("user.dir")+"/mappe/"+nome.getText()+"/"+cell_audio.get(d));
			        try 
			        {	h.createNewFile();
					} 
			        catch (IOException evt) 
			        {	// TODO Auto-generated catch block
						evt.printStackTrace();
					}	
				}
			}
		});
		tutorial=new Button("tutorial");
		Tooltip tutorial_tip=new Tooltip("apre la pagina tutorial");
		tutorial.setTooltip(tutorial_tip); 
		tutorial.setOnMouseClicked(e -> 
		{	File tutorial=new File("tutorial/tutorial.html");
			HostServices billo = getHostServices();
			billo.showDocument(tutorial.toURI().toString());			
		});
		esempi=new Button("esempi");
		Tooltip esempi_tip=new Tooltip("esempi da Youtube");
		esempi.setTooltip(esempi_tip);
		esempi.setOnMouseClicked(e -> 
		{	HostServices billo = getHostServices();
			billo.showDocument("https://www.youtube.com/playlist?list=PLokw5HXtI9mbOwPeDVYG1rePTLDVGtGzZ");			
		});
		//hPanel
      	hPanel.add(new ImageView(image),1,0);
      	hPanel.add(nome,2,0);
      	hPanel.add(materia,3,0);
      	hPanel.add(autore,4,0);
      	hPanel.add(n_cols,5,0);
      	hPanel.add(n_rows,6,0);
      	hPanel.add(anteprima,7,0);
      	borderPane.setTop(hPanel);
      	Node [] hnodes= {new ImageView(image),nome,materia,autore,n_cols,n_rows,anteprima};
      	for(int a=0;a<hnodes.length;a++)
      	{	GridPane.setHalignment(hnodes[a], HPos.CENTER);
      	}
      	//lPanel
      	lPanel.add(nomec, 0, 0);
      	lPanel.add(colorec, 2, 0);
      	lPanel.add(sfondoc, 2, 1);
      	lPanel.add(acapo1, 2, 2);
      	lPanel.add(testoc, 0, 1,2,3);
      	lPanel.add(alli_combo, 1, 0);
      	lPanel.add(grassetto1, 2, 3);      	
      	lPanel.add(numeror, 3, 2);      	
      	lPanel.add(span_row, 3, 3);      	
      	lPanel.add(numeroc, 3, 0);
      	lPanel.add(span_col, 3, 1);       	
      	lPanel.add(finestra_dxsx, 1, 4);
      	lPanel.add(titolo, 0, 4);
      	lPanel.add(appro, 2, 4);
      	lPanel.add(appro_text, 0,5,2,3); 
      	lPanel.add(crea_cella, 3, 4);
      	lPanel.add(annulla, 3, 5);
      	lPanel.add(pulisci, 3, 6);
      	lPanel.add(immagine, 2, 5);      	
      	lPanel.add(acapo2, 2, 6);
      	lPanel.add(grassetto2, 2, 7);
      	lPanel.setMaxSize(Region.USE_PREF_SIZE, Region.USE_PREF_SIZE);
      	Node [] lnodes= {appro,nomec,colorec,sfondoc,testoc,grassetto1,grassetto2,acapo1,acapo2,alli_combo,numeroc,numeror,span_col,span_row,appro_text,titolo,immagine,finestra_dxsx,annulla,pulisci};
      	for(int a=0;a<lnodes.length;a++)
      	{	GridPane.setHalignment(lnodes[a], HPos.CENTER);
      	}      	
      	//bPanel
      	bPanel.add(reset, 0, 0);
      	bPanel.add(tutorial, 1, 0);
      	bPanel.add(esempi, 2, 0);
      	bPanel.add(salva, 3,0);
      	bPanel.add(apri, 4, 0);      	
      	Rectangle2D primaryScreenBounds = Screen.getPrimary().getVisualBounds();
		primaryStage.setX(primaryScreenBounds.getMinX());
		primaryStage.setY(primaryScreenBounds.getMinY());
		primaryStage.setWidth(primaryScreenBounds.getWidth());
		primaryStage.setHeight(primaryScreenBounds.getHeight());
      	double w=primaryScreenBounds.getWidth()-primaryScreenBounds.getMinX();
		if(w>1800)
		{	borderPane.getStyleClass().add("main-root");
			hPanel.setPadding(new Insets(3,10,3,10));
			hPanel.setHgap(100);
	      	hPanel.setVgap(5);
	      	lPanel.setPadding(new Insets(5,20,5,20));
	      	lPanel.setVgap(70);
	      	lPanel.setHgap(50);
	      	bPanel.setPadding(new Insets(5,200,5,200));
	      	bPanel.setHgap(200);
	      	bPanel.setVgap(2);
		}
		if(w>1500&&w<1800)
		{	borderPane.getStyleClass().add("main-root2");
			hPanel.setPadding(new Insets(2,5,2,5));
			hPanel.setHgap(70);
	      	hPanel.setVgap(2);
	      	lPanel.setPadding(new Insets(10,10,10,10));
	      	lPanel.setVgap(40);
	      	lPanel.setHgap(30);
	      	bPanel.setPadding(new Insets(3,100,3,100));
	      	bPanel.setHgap(200);
	      	bPanel.setVgap(2);
		}
		if(w>1200&&w<1500)
		{	borderPane.getStyleClass().add("main-root3");
			hPanel.setPadding(new Insets(2,3,2,3));
			hPanel.setHgap(50);
	      	hPanel.setVgap(1);
	      	lPanel.setPadding(new Insets(5,5,5,5));
	      	lPanel.setVgap(25);
	      	lPanel.setHgap(20);
	      	bPanel.setPadding(new Insets(2,50,2,50));
	      	bPanel.setHgap(120);
	      	bPanel.setVgap(1);
		}
		if(w>900&&w<1200)
		{	borderPane.getStyleClass().add("main-root4");
			hPanel.setPadding(new Insets(1,2,1,2));
			hPanel.setHgap(20);
	      	hPanel.setVgap(1);
	      	lPanel.setPadding(new Insets(2,2,2,2));
	      	lPanel.setVgap(20);
	      	lPanel.setHgap(10);
	      	bPanel.setPadding(new Insets(1,20,1,20));
	      	bPanel.setHgap(80);
	      	bPanel.setVgap(1);
		}
		if(w<900)
		{	borderPane.getStyleClass().add("main-root5");
			hPanel.setPadding(new Insets(1,1,1,1));
			hPanel.setHgap(5);
	      	hPanel.setVgap(1);
	      	lPanel.setPadding(new Insets(1,1,1,1));
	      	lPanel.setVgap(5);
	      	lPanel.setHgap(5);
	      	bPanel.setPadding(new Insets(5,100,5,100));
	      	bPanel.setHgap(20);
	      	bPanel.setVgap(2);
		}
		borderPane.setCenter(rPanel);
      	borderPane.setLeft(lPanel);
      	borderPane.setBottom(bPanel);
      	Scene scene = new Scene(borderPane);
      	primaryStage.setScene(scene);
        primaryStage.sizeToScene();
        scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());               
        borderPane.prefWidthProperty().bind(scene.widthProperty());
        borderPane.prefHeightProperty().bind(scene.heightProperty());        
	    primaryStage.show();  
	}
	public void showAlert(String b)
    {	Alert alert = new Alert(AlertType.WARNING);
		alert.setTitle("Errore");
		alert.setHeaderText(null);
		alert.setContentText(b);
		alert.showAndWait();    	
    }  
	class colorPicker extends Application 
	{   @Override
	    public void start(Stage stage) 
		{   ColorPicker colorPicker = new ColorPicker(Color.WHITE);
	        final Circle circle = new Circle(50);
	        circle.setFill(colorPicker.getValue()); 
	        colorPicker.setOnAction(new EventHandler<ActionEvent>() 
	        {   @Override
	            public void handle(ActionEvent event) 
	        	{   circle.setFill(colorPicker.getValue());
	        		Color col=colorPicker.getValue();
	        		colorS=col.toString().substring(2);
				 	colorS="#"+colorS.substring(0,colorS.length()-2);				 	
	            }
	        }); 
	        Button getCol = new Button("OK");
	        getCol.setPrefWidth(200);
	        getCol.setOnMouseClicked(e ->
	        {		sfondoc.setText(colorS);
	        		stage.close();			
			});        
	        AnchorPane root= new AnchorPane(circle, colorPicker,getCol);
	        root.getStyleClass().add("main-root");
	        root.setPadding(new Insets(10));
	        //root.setHgap(10);
	        AnchorPane.setLeftAnchor(circle, 0.0);
	        AnchorPane.setTopAnchor(circle, 10.0);
	        AnchorPane.setLeftAnchor(colorPicker, 150.0);
	        AnchorPane.setTopAnchor(colorPicker, 30.0);
	        AnchorPane.setLeftAnchor(getCol, 50.0);
	        AnchorPane.setTopAnchor(getCol, 200.0);
	        Scene scene = new Scene(root, 400, 300); 
	        scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
	        stage.setTitle("Borumir pannello colori dello sfondo"); 
	        stage.setScene(scene);
	        stage.show();
	    } 
	}
}